package ftp

import (
	cnsmf "git.loafle.net/commons/service_matcher-go/ftp"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type FTPHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *FTPHealthCrawler) Key() string {
	return "FTP_HEALTH"
}

func (c *FTPHealthCrawler) String() string {
	return "FTP Health Crawler"
}

func (c *FTPHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *FTPHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &FTPHealthCrawler{}
	c.SetMatcher(cnsmf.NewMatcher())
	return c
}
