package mysql

import (
	cnsmm "git.loafle.net/commons/service_matcher-go/mysql"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	"git.loafle.net/overflow/crawler-go"
)

type MySQLHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *MySQLHealthCrawler) Key() string {
	return "MYSQL_HEALTH"
}

func (c *MySQLHealthCrawler) String() string {
	return "MySQL Health Crawler"
}

func (c *MySQLHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *MySQLHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &MySQLHealthCrawler{}
	c.SetMatcher(cnsmm.NewMatcher())
	return c
}
