package redis

import (
	cnsmr "git.loafle.net/commons/service_matcher-go/redis"
	ocmsc "git.loafle.net/overflow/commons-go/model/sensorconfig"
	"git.loafle.net/overflow/container_network/crawler/health"
	crawler "git.loafle.net/overflow/crawler-go"
)

type RedisHealthCrawler struct {
	health.SocketHealthCrawler
}

func (c *RedisHealthCrawler) Key() string {
	return "REDIS_HEALTH"
}

func (c *RedisHealthCrawler) String() string {
	return "Redis Health Crawler"
}

func (c *RedisHealthCrawler) Auth(auth map[string]interface{}) error {
	return nil
}

func (c *RedisHealthCrawler) Get(config *ocmsc.SensorConfig) (map[string]string, error) {
	rss, err := c.CheckHealth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	c := &RedisHealthCrawler{}
	c.SetMatcher(cnsmr.NewMatcher())
	return c
}
